package sharecode.actions;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.action.Action;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.ui.IEditorDescriptor;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.FileEditorInput;

import sharecode.core.Activator;
import sharecode.core.model.FileMessage;
import sharecode.util.ProjectListElement;

public class DisplayFileAction extends Action {

	private FileMessage scpFile;

	public DisplayFileAction(FileMessage scpFile){
		this.scpFile = scpFile;
	}
	
	//TODO esse metodo ta muito grande e a logica tambem nao esta boa
	public void run() {
		
		IProject project;
		
		Iterator iter = ProjectListElement.stringsToProjectsList().iterator(); 
    	
    	if (iter.hasNext()) {
			ProjectListElement element = (ProjectListElement) iter.next();
			project = element.getProject();	
						
		}else{		
			IWorkspace w = ResourcesPlugin.getWorkspace();
			project = w.getRoot().getProject("temporarysharecodefile");
			try {
				if(!project.exists())
					project.create(null);
				project.open(null);
				
			} catch (CoreException e) {
				// TODO Tratar Log
				e.printStackTrace();
			}

		}
		
		
		IFolder folder = project.getFolder("/.sharedcode");

		if(!folder.exists()){
			try{
				folder.create(true, true, null);
			}
			catch (CoreException e){
				e.printStackTrace();
			}
		}
		
		InputStream is = new ByteArrayInputStream(scpFile.getData());
		
		final IFile f = folder.getFile("Temporary.java");
		try {
			if(f.exists())
				f.delete(true, null);
			
			f.create(is, true, null);
			is.close(); 
		} catch (CoreException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		final IWorkbench workbench = Activator.getDefault().getWorkbench();	
		
		if (workbench != null) {
			final IWorkbenchPage page = workbench.getWorkbenchWindows()[0].getActivePage();

			workbench.getDisplay().asyncExec(new Runnable() {
				

				public void run() {
					try {
						IEditorDescriptor editorDescriptor = workbench.getEditorRegistry().getDefaultEditor(f.getName());

						//There is no direct file type association.  Use the default.
						if (editorDescriptor == null) {
							editorDescriptor = workbench.getEditorRegistry().findEditor("org.eclipse.ui.DefaultTextEditor");
						}
						
						if (editorDescriptor == null) {
							//Give up, can't get an editor.
							Activator.getDefault().getLog().log(new Status(IStatus.ERROR, Activator.PLUGIN_ID, 0, "Failed to get editor for file.  Aborting shared editing session.", null));
							return;
						}
						
						
						
						//Open the default editor for the selected file.
						IEditorPart editorPart = page.openEditor(new FileEditorInput(f), editorDescriptor.getId());


					} catch (PartInitException e) {
						Activator.getDefault().getLog().log(new Status(IStatus.ERROR, Activator.PLUGIN_ID, 0, e.getLocalizedMessage(), e));
					}
					
				}

			});
		}
		
		
		
		
		
		
	
	}
	

	
}
