package sharecode.asynchronous;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

import sharecode.exception.ShareCodeException;
import sharecode.message.SharedCodeMessage;
import sharecode.util.Tracer;

public class RequestQueue {
	
	private BlockingQueue<SharedCodeMessage> requestQueue;
	
	public RequestQueue(){
		this.requestQueue = new LinkedBlockingQueue<SharedCodeMessage>();
	}
	
	/**
	 * 
	 * @param message
	 * @throws ShareCodeException
	 */
	public void addMessage(SharedCodeMessage message)throws ShareCodeException{
		
		boolean allOk = requestQueue.offer(message);
		
		if(!allOk){
			//TODO precisar logar isso
			Tracer.trace(this, "Nao teve sucesso ao adicionar na fila");
		}
		Tracer.trace(this, "Message :: "+message.getMessageId()+" added to RequestQueue, queue size :: "+requestQueue.size());
		//TODO analisar se o metodo check ter funcionalidade
		check();
		
	}

	/**
	 * 
	 *
	 */
	private void check() {
		// TODO esse metodo verifica se a thread consumer esta rodando 
		// TODO como prosseguir?
		//ThreadConsumer tConsumer = new ThreadConsumer();
		//tConsumer.start();
		
	}

	public SharedCodeMessage take() throws ShareCodeException{
		// TODO precisa analisar se existe a necessidade de tratar a thread
		try {
			return requestQueue.take();
		} catch (InterruptedException e) {
			throw new ShareCodeException(e);
		}
		
	}

}
